@import "./variables.less";

@headerHeight: 48px;
@sidebarWidth: 220px;
@showcaseHeight: 220px;
@detailHeight: 30px;
@attributeHeight: 80px;
@navigationHeight: 32px;
@abilityHeight: 36px;

/* ----------------------------------------- */
/*  Generic Sheet Styling
/* ----------------------------------------- */

.dnd5e.sheet form {
  width: 100%;
  height: 100%;
  overflow: hidden;

  /* Form Elements */
  input[type="text"] {
    width: calc(100% - 2px);
    height: calc(100% - 2px);
    background: none;
    padding: 0;
    margin: 1px 0;
    color: #444;
    border: 1px solid transparent;

    &:hover,
    &:focus {
      border: 1px solid #111;
      box-shadow: 0 0 8px red;
    }
  }

  /* Select Fields */
  select {
    font-size: 10px;
    height: 18px;
    background: rgba(255,255,255,0.5);
  }

  input:disabled,
  select:disabled,
  textarea:disabled {
    color: #444;
    border: none;
    &:hover,
    &:focus {
      border: none;
      box-shadow: none;
    }
  }

  label {
    display: block;
  }
  .mce-panel span {
    display: inherit;
  }

  &.editable .rollable:hover {
    color: #000;
    text-shadow: 0 0 10px red;
    cursor: pointer;
  }

  /* Sheet Tabs */
  .sheet-tabs {
    height: @navigationHeight;

    > .item {
      line-height: @tabHeight - 4px;
      padding: 2px 8px 0;
      margin-bottom: 1px;

      &.active {
        color: #000;
        font-weight: 700;
      }
    }
  }

  .tab {
    flex: 1;
    overflow: hidden;
  }

  /* Tags */
  .tag {
    float: left;
    margin: 0 2px 2px 0;
    padding: 0 3px;
    font-size: 10px;
    line-height: 16px;
    border: 1px solid #999;
    border-radius: 3px;
    background: rgba(0, 0, 0, 0.05);
  }
}


/* ---------------------------------------- */
/*  Actor Sheet
/* ---------------------------------------- */

.dnd5e.actor {
  min-width: 650px;
  min-height: 650px;

  .sidebar {
    float: left;
    width: @sidebarWidth;
  }

  .content {
    float: right;
    width: calc(100% - @sidebarWidth);
  }

  .sheet-upper {
    width: 100%;
    height: @headerHeight + @showcaseHeight;

    .sheet-header {
      height: @headerHeight;
    }

    .sheet-profile {
      height: @showcaseHeight;
    }

    .sheet-showcase {
      height: @showcaseHeight;
    }
  }

  .sheet-navigation {
    height: @navigationHeight;
    width: 100%;
  }

  .sheet-lower {
    width: 100%;
    height: calc(100% - @headerHeight - @showcaseHeight - @navigationHeight);

    .sheet-content {
      height: 100%;
    }
  }

  .sheet-sidebar {
    height: 100%;
    .flexcol();
  }

  /* NPC Sheet Adjustments */
  &.npc-sheet {
    .sheet-upper {
      height: @showcaseHeight;
      .sheet-showcase {
        height: calc(@showcaseHeight - @headerHeight)
      }
    }
    .sheet-lower {
      height: calc(100% - @showcaseHeight - @navigationHeight);
    }
  }

  /* ---------------------------------------- */
  /*  Navigation Tabs
  /* ---------------------------------------- */

  .sheet-navigation {
    border-top: 1px solid @borderLight;
    border-bottom: 1px solid @borderDark;

    .sheet-tabs > .item {
      border-radius: 5px 5px 0 0;
      &.active {
        border: 1px solid @borderDark;
        border-bottom: none;
        box-shadow: 0 0 10px inset @accentColor;
        text-shadow: none;
      }
    }
  }

  /* ---------------------------------------- */
  /*  Header Content
  /* ---------------------------------------- */

  .sheet-header {
    border-bottom: 1px solid @borderLight;

    h1 {
      margin: 0;
      border: none;
      > input {
        height: 40px;
        width: 100%;
        margin: 2px;
        .nodesto();
        font-size: 36px;
      }
    }

    .charlevel {
      flex: 0 0 150px;
      height: 44px;
      .flexcol();
      text-align: right;

      .level {
        flex: 0 0 20px;
        width: 100%;
        .flexrow();
        .nodesto();
        font-size: 20px;
        line-height: 20px;

        > input {
          flex: 0 0 26px;
          height: 20px;
          text-align: center;
        }

        /* If the Experience Bar is disabled */
        &.noxp {
          flex: 0 0 44px;
          font-size: 32px;
          line-height: 44px;
          > input {
            flex: 0 0 40px;
            height: 44px;
          }
        }
      }

      .xpbar {
        width: 100%;
        flex: 0 0 8px;
        background: #666;
        border: 1px solid #000;
        border-radius: 3px;

        .bar {
          height: 4px;
          margin: 1px;
          display: block;
          background: #afebff;
          border: 1px solid #000;
          border-radius: 2px;
        }
      }

      .experience {
        flex: 0 0 16px;
        .flexrow();
        justify-content: flex-end;

        > input[type="text"] {
          flex: 1;
          text-align: right;
          height: 16px;
        }
      }
    }
  }

  /* ---------------------------------------- */
  /*  Showcase Content
  /* ---------------------------------------- */

  /* Character Details */
  .details {
    height: @detailHeight;
    list-style: none;
    margin: 0;
    padding: 0;
    border-bottom: 1px solid @borderLight;

    .character-detail {
      width: 33.33%;
      height: @detailHeight;
      float: left;
      padding: 3px;
      border-right: 1px solid @borderLight;

      &:last-child {
        border-right: none;
      }

      > input {
        .nodesto();
        font-size: 20px;
      }
    }
  }

  /* Primary Attributes */
  .primary-attributes {
    height: @attributeHeight;
    width: 100%;
    .flexrow();
    border-bottom: 1px solid @borderLight;

    .attribute {
      flex: 0 0 25%;
      height: 79px;
      padding: 4px;
      border-right: 1px solid @borderLight;

      &:last-child {
        margin-right: 0;
        border-right: none;
      }

      .attribute-name {
        position: relative;
        height: 22px;
        margin: 0 0 2px;
        line-height: 22px;
        .nodesto();
        text-align: center;
        border-bottom: 1px solid @borderLight;

        .npc-roll-hp {
          position: absolute;
          right: 2px;
        }
      }

      .attribute-value {
        height: 32px;
        .nodesto();
        font-size: 20px;
        line-height: 32px;
        text-align: center;
      }

      .attribute-footer {
        height: 16px;
        text-align: center;

        span {
          display: inline-block;
        }

        input {
          max-width: 24px;
        }

        input.temphp {
          max-width: 45%;
        }

        input.hit-dice {
          min-width: 16px;
          max-width: 16px;
          text-align: right;
        }

        input[name="data.attributes.speed.value"] {
          max-width: none;
          text-align: left;
        }

        input.speed,
        input.hpformula {
          max-width: 90%;
        }

        a.rest {
          padding: 0 2px;
          background: rgba(255, 255, 255, 0.25);
          border: 1px solid @borderLight;
          border-radius: 2px;
        }

        &.recharge input[type="checkbox"]{
          margin: 1px;
        }
      }
    }
  }

  /* Status Effects */
  .statuses {
    width: 100%;
    height: @detailHeight;
    margin: 0;
    .flexrow();

    .status {
      line-height: @detailHeight;
      padding: 0 6px;
      border-right: 1px solid @borderLight;
      font-size: 14px;
      .flexrow();

      &.death {
        flex: 0 0 50%;
      }

      &:last-child {
        border-right: none;
      }

      h4 {
        flex: 1;
        margin: 0;
        font-size: 12px;
        .nodesto();
      }

      .status-value {
        flex: none;
        > * {
          display: inline-block;
          margin-right: 5px;
        }

        > input[type="text"] {
          height: 20px;
          max-width: 20px;
          margin: 0;
        }

        > input[type="checkbox"] {
          position: relative;
          top: 2px;
        }
      }
    }
  }

  /* ---------------------------------------- */
  /*  Sidebar Content
  /* ---------------------------------------- */

  // Profile Image
  img.sheet-profile {
    border: none;
    border-right: 1px solid @borderLight;
    object-fit: contain;
  }

  // Sidebar Tabs
  .sheet-sidebar {
    border-right: 1px solid #AAA;
    .tab {
      height: 100%;
      padding-top: 2px;
      overflow-y: auto;
    }
  }

  /* ---------------------------------------- */
  /*  Abilities Tab
  /* ---------------------------------------- */

  .abilities {
    .abilities-list {
      list-style: none;
      margin: 0;
      padding: 0;
    }

    .ability {
      .flexrow();
      height: @abilityHeight;
      line-height: @abilityHeight;
      border-bottom: 1px solid @borderLight;

      .ability-proficiency {
        flex: 0 0 20px;
        height: 100%;
        text-align: left;
        padding-left: 3px;
        i.fa-circle { font-size: 10px; }
      }

      .ability-name {
        .nodesto();
        margin: 0;
      }

      .ability-score {
        flex: 0 0 36px;
        height: @abilityHeight;
        > input {
          width: 30px;
          height: 30px;
          margin: 3px;
          .nodesto();
          font-size: 22px;
          text-align: center;
        }
      }

      .ability-mod,
      .ability-save {
        flex: 0 0 24px;
        .nodesto();
        line-height: @abilityHeight;
        color: #666;
        text-align: center;
      }
      .ability-mod { border-right: 1px solid @borderLight; }
      .ability-save { border-left: 1px solid @borderLight; }
    }
  }

  /* ----------------------------------------- */
  /* Class List
  /* ----------------------------------------- */

  .class-levels {
    margin: 0 5px 0 0;
    height: 156px;
    overflow: hidden;

    .class-header {
      line-height: 20px;
      position: relative;
      margin: 3px 0 1px;

      h3 {
        text-align: center;
        .nodesto();
        font-size: 18px;
        color: #222;
        margin: 0;
      }

      a.item-create {
        position: absolute;
        top: 0;
        right: 0;
        font-size: 11px;
        color: #666;
      }
    }

    .class-list {
      overflow-y: hidden;

      .item {
        height: 44px;
        background: rgba(0, 0, 0, 0.03);
        padding: 2px;
        border: 1px solid @borderLight;
        border-radius: 2px;
        margin-bottom: 2px;

        h4, h5 {
          width: calc(100% - 44px);
          float: left;
          margin: 0;
          line-height: 20px;
          font-weight: strong;
        }

        .item-header {
          flex: 0 0 100%;
          height: 20px;

          .class-levels {
            width: 44px;
            height: 100%;
            float: right;
            margin: 0;
            font-size: 10px;
            text-align: right;
            .nodesto();
            color: #222;
          }
        }

        .class-subclass {
          flex: 0 0 100%;
          height: 20px;

          .item-controls {
            width: 44px;
            float: right;
            a { text-align: right };
          }
        }
      }
    }
  }

  /* ---------------------------------------- */
  /*  Skills Tab
  /* ---------------------------------------- */

  .skills {
    .skills-list {
      margin: 0;
      padding: 0;
      list-style: none;
    }
    .skill {
      .flexrow();
      height: 21px;
      line-height: 21px;
      border-bottom: 1px solid @borderLight;
      font-size: 13px;

      .skill-name {
        margin: 0;
      }

      .skill-proficiency {
        text-align: left;
        flex: 0 0 20px;
        padding-left: 3px;
        i.fa-circle { font-size: 10px; }
      }

      .skill-ability {
        flex: 0 0 36px;
        color: #666;
        text-align: right;
        margin-right: 4px;
      }

      .skill-mod {
        flex: 0 0 28px;
        text-align: center;
      }
    }
  }

  &.locked .ability-proficiency,
  &.locked .skill-proficiency {
    text-shadow: none;
    cursor: default;
  }

  /* ----------------------------------------- */
  /* Traits Tab
  /* ----------------------------------------- */

  .traits {
    label {
      font-weight: bold;
    }
    select {
      margin: 2px 0;
    }

    .trait-perception > input {
      flex: 0 0 32px;
      text-align: center;
    }

    .trait-selector {
      float: right;
      margin-right: 3px;
      color: #999;
      font-size: 10px;
      line-height: 16px;
    }

    .traits-list {
      list-style: none;
      margin: 0;
      padding: 0;
    }

    .configure-flags i.fas {
      float: right;
      margin-right: 3px;
      text-align: right;
      color: #999;
      line-height: 24px;

      &:hover {
        color: #111;
        text-shadow: 0 0 10px @accentColor;
      }
    }
  }

  /* ----------------------------------------- */
  /*  Main Content Tabs
  /* ----------------------------------------- */

  /* Biography */
  .biography {
    .editor {
      height: 380px;
      .editor-content {
        padding-left: 8px;
      }
    }
  }
  &.npc-sheet .biography .editor {
    height: 465px;
  }

  /* ----------------------------------------- */
  /* Inventory Tab
  /* ----------------------------------------- */

  .currency {
    list-style: none;
    margin: 0;
    padding: 0;
    border-bottom: 1px solid @borderLight;
    .flexrow();
    height: 24px;
    font-size: 12px;
    line-height: 20px;

    li.denomination {
      .flexrow();
      padding: 3px 3px 0;
      justify-content: flex-end;
      border-right: 1px solid @borderLight;

      label {
        flex: none;
        margin-right: 3px;
      }

      input {
        text-align: right;
        max-width: 48px;
      }

      &:last-child {
        border-right: none;
      }
    }
  }

  /* Inventory List */
  .inventory-list {
    list-style: none;
    margin: 0;
    padding: 0;
    height: 100%;
    overflow-y: auto;

    /* Inventory Item */
    .item {
      line-height: 24px;
      padding: 0;
      border-bottom: 1px solid @borderLight;

      .item-name {
        cursor: pointer;

        .item-image {
          flex: 0 0 24px;
          margin-right: 6px;
          background-size: 24px;
          background-repeat: no-repeat;
        }

        h4 {
          flex: 2;
          margin: 0;
        }

        .prepared {
          color: #666;
          margin-left: 3px;
          font-size: 10px;
        }

        .item-charges {
          color: #666;
          font-size: 12px;
          flex: 0;
        }

        &:hover .item-image {
          background-image: url("/icons/svg/d20-grey.svg") !important;
        }
        .item-image:hover {
          background-image: url("/icons/svg/d20-black.svg") !important;
        }
      }

      .item-quantity, .item-weight {
        flex: 0 0 32px;
        font-size: 12px;
        color: #666;
        text-align: center;
        border-right: 1px solid @borderLight;
      }

      .item-controls {
        flex: 0 0 44px;

        a {
          display: block;
          float: left;
          width: 22px;
          font-size: 10px;
          text-align: center;
          color: #666;
        }
      }

      /* Item Dropdown Summary */
      .item-summary {
        flex: 0 0 100%;
        font-size: 12px;
        line-height: 16px;
        padding: 0.25em 0.5em;
        border-top: 1px solid #CCC;
      }
    }

    /* Inventory Header */
    .inventory-header {
      font-weight: 700;
      line-height: 20px;
      background: rgba(0, 0, 0, 0.05);

      h3 {
        flex: 2;
        font-size: 1em;
        margin: 0;
        padding-left: 32px;
        font-weight: bold;
      }

      .item-quantity, .item-weight {
        color: #111;
      }

      .item-controls a.item-create {
        width: 100%;
      }
    }
  }

  &.character-sheet .inventory-list {
    height: calc(100% - 42px);
  }

  /* Encumbrance Bar */
  .encumbrance {
    background: rgba(0,0,0,0.1);
    height: 12px;
    margin-top: 5px;
    border: 1px solid #111;
    border-radius: 3px;
    position: relative;

    .encumbrance-bar {
      position: absolute;
      top: 1px;
      left: 1px;
      background: #a59b89;
      height: 8px;
      border: 1px solid #6f5439;
      border-radius: 3px;
    }

    .encumbrance-label {
      position: absolute;
      top: -3px;
      height: 16px;
      font-size: 16px;
      line-height: 16px;
      color: #000;
      background: rgba(255, 255, 255, 0.4);
      padding: 0 3px;
    }

    .encumbrance-breakpoint {
      position: absolute;
      left: 66%;
    }

    .arrow-up {
      bottom: 0;
      width: 0;
      height: 0;
      border-left: 4px solid transparent;
      border-right: 4px solid transparent;
      border-bottom: 4px solid #666;
    }

    .arrow-down {
      top: 0;
      width: 0;
      height: 0;
      border-left: 4px solid transparent;
      border-right: 4px solid transparent;
      border-top: 4px solid #666;
    }

    &.encumbered {
      .arrow-up { border-bottom: 4px solid #000; }
      .arrow-down { border-top: 4px solid #000; }
    }
  }

  /* ----------------------------------------- */
  /*  Spellbook Tab
  /* ----------------------------------------- */

  .spellbook {
    .spellcasting-ability {
      margin: 0;
      padding: 3px 3px 0;
      border-bottom: 1px solid @borderLight;
      font-size: 12px;
      label {
        line-height: 20px;
      }
      select {
        flex: 1;
      }
    }

    .spellbook-header {
      .spell-school, .spell-action {
        color: inherit;
      }
    }

    .prepared-toggle {
      flex: 0 0 20px;
      line-height: 20px;
      margin-left: 5px;
    }

    // Spellbook spell list
    .inventory-list {
      height: calc(100% - 28px);
    }

    // Individual spell items
    .item {
      .item-name {
        flex: 2;
      }

      .spell-school, .spell-action {
        flex: 1;
        font-size: 12px;
        color: #666;
        text-align: center;
        border-right: 1px solid @borderLight;
      }

      .spell-slots, .spell-max {
        flex: 0 0 24px;
        font-size: 12px;
        text-align: center;
      }

      .spell-max {
        border-right: 1px solid @borderLight;
      }
    }

    // Empty spellbook controls
    .spellbook-empty .item-controls { flex: 1; }
  }

  // Extended Actor Sheet spellbook controls
  &.character-sheet .spellbook .item-controls { flex: 0 0 66px; }


  /* ----------------------------------------- */
  /*  Feats Tab
  /* ----------------------------------------- */

  .feats {
    .feats-list {
      height: 100%;
      .item-name {
        flex: 2;
      }
    }
  }

  .feat-uses {
    display: inline;
    font-size: 11px;
    color: #444;
  }

  /* ----------------------------------------- */
  /* Rest Buttons
  /* ----------------------------------------- */

  #short-rest-hd {
    label {
      flex: 0 0 60px;
      line-height: 24px;
    }

    #roll-hd {
      line-height: 24px;
      margin-left: 6px;
    }
  }
}


/* ----------------------------------------- */
/* Trait Selector
/* ----------------------------------------- */

#trait-selector {
  .trait-list {
    list-style: none;
    margin: 0 0 0.5em;
    padding: 0;
  }
}


/* ----------------------------------------- */
/* Special Traits and Flags
/* ----------------------------------------- */

#actor-flags {
  h3.flags-section {
      background: rgba(0, 0, 0, 0.05);
      border: 1px solid #999;
      border-radius: 3px;
      padding: 3px;
      margin: 0;
      font-weight: bold;
      font-size: inherit;
  }  
}
